package sorts;

import util.OArrays;

/**
 * Sort.java
 * Created by Stijn Strickx on May 21, 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */

/**
 * The datatype conversions for the arrays won't influence 
 * the time complexity of the sorting algorithms.
 * Without these conversions,
 * the algorithms would have to be re-written for every primitive datatype.
 */

public class Sort {
    
    public static <T extends Comparable<? super T>> void quickSort(T[] a){
        (new QuickSort()).sort(a);
    }
    public static int[] quickSort(int[] a){
        Integer[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static long[] quickSort(long[] a){
        Long[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static double[] quickSort(double[] a){
        Double[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static float[] quickSort(float[] a){
        Float[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static char[] quickSort(char[] a){
        Character[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static boolean[] quickSort(boolean[] a){
        Boolean[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static byte[] quickSort(byte[] a){
        Byte[] b = OArrays.toObjectArray(a);
        quickSort(b);
        return OArrays.toPrimitiveArray(b);
    }
}